import time
from machine import Pin

brakelights = Pin(10, Pin.OUT)
headlights = Pin(11, Pin.OUT)
trig = Pin(12, Pin.OUT)
echo = Pin(13, Pin.IN)
in1 = Pin(16, Pin.OUT)
in2 = Pin(17, Pin.OUT)
in3 = Pin(18, Pin.OUT)
in4 = Pin(19, Pin.OUT)
enable = Pin(20, Pin.OUT)

pins_list = [in1, in2, in3, in4]

FWD = [0, 1, 1, 0]
REV = [1, 0, 0, 1]
LEFT = [0, 1, 0, 1]
RIGHT = [1, 0, 1, 0]
BRAKE = [0, 0, 0, 0]


def go(logic_levels):
    global pins_list
    enable.value(0)
    time.sleep(0.2)
    for i in range(4):
        if logic_levels[i]== 0:
            pins_list[i].value(0)
        else:
            pins_list[i].value(1)
    enable.value(1)
    return

def scan():
    trig.value(0)
    time.sleep_us(5)             
    trig.value(1)
    time.sleep_us(10)
    trig.value(0)
    while echo.value() == 0:
        pass
    start = time.ticks_us()
    while echo.value() == 1:
        pass
    stop = time.ticks_us()
    pulse = time.ticks_diff(stop, start)
    return pulse

def flash_headlights():
    for i in range (3):
        headlights.value(1)
        time.sleep(0.3)
        headlights.value(0)
        time.sleep(0.3)    

headlights.value(0)
brakelights.value(0)
for i in range (5):
    headlights.value(1)
    brakelights.value(1)
    time.sleep(0.5)
    headlights.value(0)
    brakelights.value(0)
    time.sleep(0.5)

go(FWD)

while True :
    fwd_dist = scan()
    if fwd_dist < 2500:
        go(REV)
        time.sleep(0.3)
        go(BRAKE)
        brakelights.value(1)
        time.sleep(1)
        brakelights.value(0)
        flash_headlights()
        go(LEFT)
        time.sleep(0.2)
        go(BRAKE)
        left_dist = scan()
        go(RIGHT)
        time.sleep(0.2)
        go(BRAKE)
        time.sleep(0.5)
        go(RIGHT)
        time.sleep(0.2)
        go(BRAKE)
        right_dist = scan()
        if right_dist > left_dist :
            go(FWD)
        else:
            go(LEFT)
            time.sleep(0.2)
            go(BRAKE)
            time.sleep(0.5)
            go(LEFT)
            time.sleep(0.2)
            go(BRAKE)
            go(FWD)
            
    

